#include "central.h"
#include "mapedit.h"
#include <allegro.h>

PALLETE pallete;

extern int Map[1000][1000];
struct UserStruct {  //Map Tiles and Flags
	int tile;
   int x;
   int y;
   int screenX;
   int screenY;
} User;

int KeyHandler()
{
  int quit = FALSE;
  int keye;
  int InMenu = FALSE;
  User.tile=0;
  User.x=0;
  User.y=0;
  User.screenX=0;
  User.screenY=0;

  InitEditor();


  do
    {
      do
      {
      }
      while (!keypressed());
      keye = readkey ();
      keye = keye >> 8;
      switch(keye)
      {
      case KEY_ENTER:
         save_bitmap("editor.bmp",screen,pallete);
         break;
      case KEY_S:
         if(key_shifts & KB_CTRL_FLAG) {
            SaveFile(); }
         break;
      case KEY_A:
         Map[User.x+(User.screenX*5)][User.y+(User.screenY*5)]=User.tile;
         DrawMap();
         break;
      case KEY_L:
         if(key_shifts & KB_CTRL_FLAG) {
            LoadFile(); }
         break;
      case KEY_D:
         if(User.tile>0)
            User.tile--;
         DrawMap();
         break;
      case KEY_F:
         User.tile++;
         DrawMap();
         break;
      case KEY_UP:
         if(key_shifts & KB_CTRL_FLAG) {
            if(User.screenY>0)
               User.screenY--;  }
         else {
            User.y--;  }
         DrawMap();
         break;
      case KEY_DOWN:
         if(key_shifts & KB_CTRL_FLAG) {
            User.screenY++; }
         else {
            User.y++; }
         DrawMap();
         break;
      case KEY_LEFT:
         if(key_shifts & KB_CTRL_FLAG) {
            if(User.screenX>0)
               User.screenX--; }
         else {
            User.x--; }
         DrawMap();
         break;
      case KEY_RIGHT:
         if(key_shifts & KB_CTRL_FLAG) {
            User.screenX++; }
         else {
            User.x++; }
         DrawMap();
         break;
      case KEY_ESC:
         quit=TRUE;
         break;
      }
   }
   while (quit != TRUE);
   return 1;
}
